import Vue from 'vue';
import { Instance } from './instance';
var Application = /** @class */ (function () {
    function Application(options) {
        this.vueClass = options.vue || Vue;
        this.vueClass.prototype.$instances || (this.vueClass.prototype.$instances = {});
    }
    Application.initialize = function (options) {
        return new Application(options);
    };
    Application.prototype.load = function (contexts) {
        var _this = this;
        // Append base instance if it is not in contexts already
        if (contexts.every(function (c) { return c.identifier !== 'base'; })) {
            contexts.push({
                identifier: 'base',
                instanceConstructor: Instance
            });
        }
        contexts.forEach(function (context) {
            var identifier = context.identifier;
            var instance = context.instanceConstructor.initialize();
            var selector = instance.el || "[instance='" + identifier + "']";
            var element = document.querySelector(selector);
            if (element) {
                var vueInstance = new _this.vueClass(instance._load(element));
                _this.vueClass.prototype.$instances[identifier] = vueInstance;
                // Update [instance="your-instance"] to [loaded-instance="your-instance"]
                vueInstance.$el.removeAttribute("instance");
                vueInstance.$el.setAttribute("loaded-instance", identifier);
            }
        });
    };
    return Application;
}());
export { Application };
//# sourceMappingURL=application.js.map